//
// sample controllers mapper
//
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "types.h"
#include "inputp.h"
#include "configure.h"
#include "config.h"

char *keyConfig="QSDWXCIOPJKL";

extern "C"
{
	__declspec(dllexport) void init(void *data)
	{
		config_load("cpsctrl.ini",keyConfig);
	}
	__declspec(dllexport) void config(void *data)
	{
		configure_gate_data *gate;
		gate=(configure_gate_data*)data;

		ConfigureDialog(gate->hInstance,gate->hWnd);
		config_save("cpsctrl.ini",keyConfig);
	}
	__declspec(dllexport) void exec(void *data)
	{
		inputPort_dll_data_gate_struct *gate;
		
		gate=(inputPort_dll_data_gate_struct*)data;

		if (!*gate->swapKeys)
        {

            if (GetAsyncKeyState(VK_LEFT))	*gate->player1JoystickLeft    = 1;	else *gate->player1JoystickLeft     = 0;
            if (GetAsyncKeyState(VK_RIGHT)) *gate->player1JoystickRight   = 1;	else *gate->player1JoystickRight     = 0;
            if (GetAsyncKeyState(VK_UP))	*gate->player1JoystickUp		= 1;	else *gate->player1JoystickUp     = 0;
            if (GetAsyncKeyState(VK_DOWN))	*gate->player1JoystickDown    = 1;	else *gate->player1JoystickDown     = 0;
        }
        else
        {
            if (GetAsyncKeyState(VK_UP)) *gate->player1JoystickLeft     = 1;		else *gate->player1JoystickLeft     = 0;
            if (GetAsyncKeyState(VK_DOWN)) *gate->player1JoystickRight     = 1;	else *gate->player1JoystickRight     = 0;
            if (GetAsyncKeyState(VK_RIGHT)) *gate->player1JoystickUp     = 1;			else *gate->player1JoystickUp     = 0;
            if (GetAsyncKeyState(VK_LEFT)) *gate->player1JoystickDown     = 1;		else *gate->player1JoystickDown     = 0;
        }
        if (GetAsyncKeyState(keyConfig[0])) *gate->player1JoystickButton1     = 1;	else *gate->player1JoystickButton1     = 0;
        if (GetAsyncKeyState(keyConfig[1])) *gate->player1JoystickButton2     = 1;	else *gate->player1JoystickButton2     = 0;
        if (GetAsyncKeyState(keyConfig[2])) *gate->player1JoystickButton3     = 1;	else *gate->player1JoystickButton3     = 0;
        if (GetAsyncKeyState(keyConfig[3])) *gate->player1JoystickButton4     = 1;	else *gate->player1JoystickButton4     = 0;
        if (GetAsyncKeyState(keyConfig[4])) *gate->player1JoystickButton5     = 1;	else *gate->player1JoystickButton5     = 0;
        if (GetAsyncKeyState(keyConfig[5])) *gate->player1JoystickButton6     = 1;	else *gate->player1JoystickButton6     = 0;


		if (GetAsyncKeyState(keyConfig[6])) *gate->player2JoystickButton1     = 1;	else *gate->player2JoystickButton1     = 0;
        if (GetAsyncKeyState(keyConfig[7])) *gate->player2JoystickButton2     = 1;	else *gate->player2JoystickButton2     = 0;
        if (GetAsyncKeyState(keyConfig[8])) *gate->player2JoystickButton3     = 1;	else *gate->player2JoystickButton3     = 0;
        if (GetAsyncKeyState(keyConfig[9])) *gate->player2JoystickButton4     = 1;	else *gate->player2JoystickButton4     = 0;
        if (GetAsyncKeyState(keyConfig[10])) *gate->player2JoystickButton5     = 1;	else *gate->player2JoystickButton5     = 0;
        if (GetAsyncKeyState(keyConfig[11])) *gate->player2JoystickButton6     = 1;	else *gate->player2JoystickButton6     = 0;


		if (GetAsyncKeyState(VK_F1)) *gate->start1=1; else *gate->start1=0;
		if (GetAsyncKeyState(VK_F2)) *gate->start2=1; else *gate->start2=0;
		if (GetAsyncKeyState(VK_F3)) *gate->coin1=1; else *gate->coin1=0;
		if (GetAsyncKeyState(VK_F4)) *gate->coin2=1; else *gate->coin2=0;
		if (GetAsyncKeyState(VK_F5)) 
		{
			if (*gate->testMode==1)
				*gate->testMode=0;
			else
				*gate->testMode=1;
		}
	
	}
	__declspec(dllexport) void info(void *data)
	{
		char msg[512];
		
		sprintf(msg,"Default controllers mapper v1.0.0\nBuild on %s (%s)",__DATE__,__TIME__);
		strcpy((char*)data,msg);
	}

}
