#include <windows.h>
#include "resource.h"

bool	bConfigureDialog;
HWND win_cfg_hwnd;
extern char *keyConfig;

BOOL CALLBACK ConfigureDialogProc( HWND hWnd, UINT message, 
						 WPARAM wParam, LPARAM lParam )
{
	HWND hCtrl;
	static BOOL bButton = FALSE;
	char	mess[1024];

	switch(message){
	case WM_CLOSE:
		bConfigureDialog=false;
		// player 1
		hCtrl = GetDlgItem(hWnd, IDC_EDIT_BUTTON1);
		SendMessage(hCtrl, WM_GETTEXT, 256, (LPARAM) (LPCTSTR)mess);
		keyConfig[0]=mess[0];
		hCtrl = GetDlgItem(hWnd, IDC_EDIT_BUTTON2);
		SendMessage(hCtrl, WM_GETTEXT, 256, (LPARAM) (LPCTSTR)mess);
		keyConfig[1]=mess[0];
		hCtrl = GetDlgItem(hWnd, IDC_EDIT_BUTTON3);
		SendMessage(hCtrl, WM_GETTEXT, 256, (LPARAM) (LPCTSTR)mess);
		keyConfig[2]=mess[0];
		hCtrl = GetDlgItem(hWnd, IDC_EDIT_BUTTON4);
		SendMessage(hCtrl, WM_GETTEXT, 256, (LPARAM) (LPCTSTR)mess);
		keyConfig[3]=mess[0];
		hCtrl = GetDlgItem(hWnd, IDC_EDIT_BUTTON5);
		SendMessage(hCtrl, WM_GETTEXT, 256, (LPARAM) (LPCTSTR)mess);
		keyConfig[4]=mess[0];
		hCtrl = GetDlgItem(hWnd, IDC_EDIT_BUTTON6);
		SendMessage(hCtrl, WM_GETTEXT, 256, (LPARAM) (LPCTSTR)mess);
		keyConfig[5]=mess[0];

		// player 2
		hCtrl = GetDlgItem(hWnd, IDC_EDIT_BUTTON7);
		SendMessage(hCtrl, WM_GETTEXT, 256, (LPARAM) (LPCTSTR)mess);
		keyConfig[6]=mess[0];
		hCtrl = GetDlgItem(hWnd, IDC_EDIT_BUTTON8);
		SendMessage(hCtrl, WM_GETTEXT, 256, (LPARAM) (LPCTSTR)mess);
		keyConfig[7]=mess[0];
		hCtrl = GetDlgItem(hWnd, IDC_EDIT_BUTTON9);
		SendMessage(hCtrl, WM_GETTEXT, 256, (LPARAM) (LPCTSTR)mess);
		keyConfig[8]=mess[0];
		hCtrl = GetDlgItem(hWnd, IDC_EDIT_BUTTON10);
		SendMessage(hCtrl, WM_GETTEXT, 256, (LPARAM) (LPCTSTR)mess);
		keyConfig[9]=mess[0];
		hCtrl = GetDlgItem(hWnd, IDC_EDIT_BUTTON11);
		SendMessage(hCtrl, WM_GETTEXT, 256, (LPARAM) (LPCTSTR)mess);
		keyConfig[10]=mess[0];
		hCtrl = GetDlgItem(hWnd, IDC_EDIT_BUTTON12);
		SendMessage(hCtrl, WM_GETTEXT, 256, (LPARAM) (LPCTSTR)mess);
		keyConfig[11]=mess[0];


		DestroyWindow(hWnd);
		return 1;

	case WM_MOVE:
	{
		SendMessage(win_cfg_hwnd, WM_MOVE, 0,0);
		return 0;
		break;
	}
	case WM_COMMAND:
		if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDOK))
		{
	
			SendMessage(hWnd, WM_CLOSE, 0,0);
			return 1;
		}
	}
		return 0;
}

void ConfigureDialog(HINSTANCE hInstance, HWND parenthWnd)
{
	HWND hwnd, hCtrl;
	MSG msg;
	char mess[2];


	bConfigureDialog=true;
	hwnd = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_DIALOG_CONFIGURE), win_cfg_hwnd, (int (__stdcall *)(void))ConfigureDialogProc);
	//hCtrl = GetDlgItem(hwnd, IDC_LIST_DSW_NAME);
	mess[1]='\0';

	hCtrl = GetDlgItem(hwnd, IDC_EDIT_BUTTON1); mess[0]=keyConfig[0]; SendMessage(hCtrl, WM_SETTEXT, 0, (LPARAM) (LPCTSTR)mess);
	hCtrl = GetDlgItem(hwnd, IDC_EDIT_BUTTON2); mess[0]=keyConfig[1]; SendMessage(hCtrl, WM_SETTEXT, 0, (LPARAM) (LPCTSTR)mess);
	hCtrl = GetDlgItem(hwnd, IDC_EDIT_BUTTON3); mess[0]=keyConfig[2]; SendMessage(hCtrl, WM_SETTEXT, 0, (LPARAM) (LPCTSTR)mess);
	hCtrl = GetDlgItem(hwnd, IDC_EDIT_BUTTON4); mess[0]=keyConfig[3]; SendMessage(hCtrl, WM_SETTEXT, 0, (LPARAM) (LPCTSTR)mess);
	hCtrl = GetDlgItem(hwnd, IDC_EDIT_BUTTON5); mess[0]=keyConfig[4]; SendMessage(hCtrl, WM_SETTEXT, 0, (LPARAM) (LPCTSTR)mess);
	hCtrl = GetDlgItem(hwnd, IDC_EDIT_BUTTON6); mess[0]=keyConfig[5]; SendMessage(hCtrl, WM_SETTEXT, 0, (LPARAM) (LPCTSTR)mess);
	hCtrl = GetDlgItem(hwnd, IDC_EDIT_BUTTON7); mess[0]=keyConfig[6]; SendMessage(hCtrl, WM_SETTEXT, 0, (LPARAM) (LPCTSTR)mess);
	hCtrl = GetDlgItem(hwnd, IDC_EDIT_BUTTON8); mess[0]=keyConfig[7]; SendMessage(hCtrl, WM_SETTEXT, 0, (LPARAM) (LPCTSTR)mess);
	hCtrl = GetDlgItem(hwnd, IDC_EDIT_BUTTON9); mess[0]=keyConfig[8]; SendMessage(hCtrl, WM_SETTEXT, 0, (LPARAM) (LPCTSTR)mess);
	hCtrl = GetDlgItem(hwnd, IDC_EDIT_BUTTON10); mess[0]=keyConfig[9]; SendMessage(hCtrl, WM_SETTEXT, 0, (LPARAM) (LPCTSTR)mess);
	hCtrl = GetDlgItem(hwnd, IDC_EDIT_BUTTON11); mess[0]=keyConfig[10]; SendMessage(hCtrl, WM_SETTEXT, 0, (LPARAM) (LPCTSTR)mess);
	hCtrl = GetDlgItem(hwnd, IDC_EDIT_BUTTON12); mess[0]=keyConfig[11]; SendMessage(hCtrl, WM_SETTEXT, 0, (LPARAM) (LPCTSTR)mess);


	ShowWindow(hwnd, SW_SHOWDEFAULT);
	UpdateWindow(hwnd);
	while(bConfigureDialog&&GetMessage(&msg, hwnd, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
}